#!/usr/bin/ruby -w
# Encoding: UTF-8
# =========================================================================== #
require 'colour_e/autoinclude'
require 'opn/module'
require 'cliner'

NAMESPACE = inspect

# =========================================================================== #
# === palegoldenrod
# =========================================================================== #
def palegoldenrod(i)
  ::Colours.palegoldenrod(i)
end
MAIN_NAMESPACE = { namespace: 'RBT::Compile' }
e ::Colours.slateblue('Seven (7)')+' examples for Opn.opn will come next -'
e 'and one example for Opn.namespace():'
cliner
e "(1) First, we test "+palegoldenrod("Opn.opn(namespace: 'YoThere')")
Opn.opn(namespace: 'YoThere'); e
cliner
e '(2) Next, we test '+palegoldenrod('Opn.opn(:no_colours)')
Opn.opn(:no_colours); e
cliner
e '(3) Next, we test '+palegoldenrod('Opn.opn')
Opn.opn; e
cliner
e '(4) Next, we test '+palegoldenrod('Opn.opn(use_colours: false)')
Opn.opn(use_colours: false); e
cliner
e '(5) Next, we test '+palegoldenrod('Opn.opn(MAIN_NAMESPACE)')+' - 4 times in total'
Opn.opn(MAIN_NAMESPACE); e
cliner
Opn.opn(MAIN_NAMESPACE); e
Opn.opn(MAIN_NAMESPACE); e
Opn.opn(MAIN_NAMESPACE); e
cliner
e '(6) Next, we will use the main namespace again but without '\
  'colours.'
e '    So: '+palegoldenrod('Opn.opn(namespace: MAIN_NAMESPACE, use_colours: false)')
Opn.opn(namespace: MAIN_NAMESPACE, use_colours: false); e
cliner
e '(7) Next, testing '+palegoldenrod('Opn.namespace NAMESPACE')
Opn.namespace NAMESPACE; e
cliner
e '(8) Next, testing '+palegoldenrod('Opn.namespace("→")')
Opn.namespace('→'); e 'Hello there!'
cliner
e '(9) Next, testing '+palegoldenrod('Opn.namespace("John→Doe")')
Opn.namespace('John→Doe'); e 'Hello there!'
cliner
e '(10) Next, testing '+palegoldenrod('Opn.opn(padding: 18)')
Opn.opn(padding: 18); e 'Hello there!'
Opn.opn(padding: 12); e 'Hello there!'
Opn.opn(padding: 22); e 'Hello there!'
cliner
e '(11) Next, testing '+palegoldenrod('Opn.opn({:namespace=>"RBT::CreateAppDirSkeleton", :use_colours=>true, :use_opn=>false})')
Opn.opn(
  {:namespace=>"RBT::CreateProgram", :use_colours=>true, :use_opn=>false}
)
cliner
e '(12) Next testing '+palegoldenrod('Opn.opn {{ use_this_colour: :green }}')+':'
Opn.opn {{ use_this_colour: :green }}; e